package org.openiec61850.common.model.datypes.basic;

import org.openiec61850.common.ServiceError;
import org.openiec61850.common.model.BasicDataAttribute;
import org.openiec61850.common.model.FunctionalConstraint;
import org.openiec61850.common.model.ObjectReference;
import org.openiec61850.common.model.datypes.DAType;

public class OCTET_STRING extends BasicDataAttribute {

	private byte[] value;
	private int maxLength;

	public OCTET_STRING(ObjectReference objectReference, FunctionalConstraint fc, String sAddr, byte[] value,
			int maxLength, boolean dchg, boolean dupd) {
		this.objectReference = objectReference;
		this.fc = fc;
		this.basicType = DAType.OCTET_STRING;
		this.sAddr = sAddr;
		this.value = value;
		this.dchg = dchg;
		this.dupd = dupd;
	}

	public byte[] getValue() {
		return value;
	}

	public void setValue(byte[] value) throws ServiceError {
		if (value.length > 6) {
			throw new ServiceError(ServiceError.PARAMETER_VALUE_INAPPROPRIATE);
		}

		this.value = value;
	}

	public int getMaxLength() {
		return maxLength;
	}

	@Override
	public void setDefault() {
		value = new byte[0];
	}

	@Override
	public OCTET_STRING copy() {
		return new OCTET_STRING(objectReference, fc, sAddr, value, maxLength, dchg, dupd);
	}

}
